#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "renju_client_com.h"
#include "match_tools.h"

void match_right(boardInfo_t *bd, point_t p, int self_enemy, matchInfo_t *mt){
  int seqNum=0;
  int returnFlag=0;
  mt->next=0;
  mt->prev=0;
  mt->seqn=0;

  // mt->prev
  if( p.x-1<0 ){// out of board
    mt->prev=-1;
  }else{ 
    mt->prev=bd->board[p.y][p.x-1];
    if( mt->prev == self_enemy )// p is not start point
      returnFlag=1;
  }
  
  // mt->seqn
  if( returnFlag == 0 ){
    while( bd->board[p.y][p.x+seqNum] == self_enemy ){
      seqNum++;
      if(p.x+seqNum>=SL){// out of board
	mt->next=-1;
	returnFlag=1;
	break;
      }
    }
    mt->seqn=seqNum;
  }


  // mt->next
  if( returnFlag == 0 )
    mt->next=bd->board[p.y][p.x+mt->seqn];
}

void match_right_down(boardInfo_t *bd, point_t p, int self_enemy, matchInfo_t *mt){
  int seqNum=0;
  int returnFlag=0;
  mt->next=0;
  mt->prev=0;
  mt->seqn=0;

  // mt->prev
  if( p.x-1<0 || p.y-1<0 ){// out of board
    mt->prev=-1;
  }else{ 
    mt->prev=bd->board[p.y-1][p.x-1];
    if( mt->prev == self_enemy )// p is not start point
      returnFlag=1;
  }
  
  // mt->seqn
  if( returnFlag == 0 ){
    while( bd->board[p.y+seqNum][p.x+seqNum] == self_enemy ){
      seqNum++;
      if(p.x+seqNum>=SL || p.y+seqNum>=SL){// out of board
	mt->next=-1;
	returnFlag=1;
	break;
      }
    }
    mt->seqn=seqNum;
  }

  // mt->next
  if( returnFlag == 0 )
    mt->next=bd->board[p.y+mt->seqn][p.x+mt->seqn];
}

void match_down(boardInfo_t *bd, point_t p, int self_enemy, matchInfo_t *mt){
  int seqNum=0;
  int returnFlag=0;
  mt->next=0;
  mt->prev=0;
  mt->seqn=0;

  // mt->prev
  if( p.y-1<0 ){// out of board
    mt->prev=-1;
  }else{ 
    mt->prev=bd->board[p.y+1][p.x];
    if( mt->prev == self_enemy )// p is not start point
      returnFlag=1;
  }
  
  // mt->seqn
  if( returnFlag == 0 ){
    while( bd->board[p.y+seqNum][p.x] == self_enemy ){
      seqNum++;
      if(p.y+seqNum>=SL){// out of board
	mt->next=-1;
	returnFlag=1;
	break;
      }
    }
    mt->seqn=seqNum;
  }

  // mt->next
  if( returnFlag == 0 )
    mt->next=bd->board[p.y+mt->seqn][p.x];
}

void match_left_down(boardInfo_t *bd, point_t p, int self_enemy, matchInfo_t *mt){
  int seqNum=0;
  int returnFlag=0;
  mt->next=0;
  mt->prev=0;
  mt->seqn=0;

  // mt->prev
  if( p.x+1<0 || p.y-1<0 ){// out of board
    mt->prev=-1;
  }else{ 
    mt->prev=bd->board[p.y-1][p.x+1];
    if( mt->prev == self_enemy )// p is not start point
      returnFlag=1;
  }
  
  // mt->seqn
  if( returnFlag == 0 ){
    while( bd->board[p.y+seqNum][p.x-seqNum] == self_enemy ){
      seqNum++;
      if(p.x-seqNum<0 || p.y+seqNum>=SL){// out of board
	mt->next=-1;
	returnFlag=1;
	break;
      }
    }
    mt->seqn=seqNum;
  }

  // mt->next
  if( returnFlag == 0 )
    mt->next=bd->board[p.y+mt->seqn][p.x-mt->seqn];
}

