#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>

#include "socket_wrapper.h"
#include "renju_client_com.h"

static void usage(char *program){
  printf("Usage:\n");
  printf("%s server_name port_number\n",program);
}
static void my_turn(int fd, char *put_cmd, char self, int myTurnNum){
  clock_t t0,t1;
  int tout=90; // [second/100];
  point_t place;
  char buf[SL*SL];

  t0 = clock();
  write( fd, "get bin", 7 );
  read( fd, buf, sizeof(buf) );
  while(1){
    place = com(buf,self,myTurnNum);
    t1 = clock();
    if( tout <= (int)((t1-t0)/(double)CLOCKS_PER_SEC*100.0) )
      break;
    if( 0<=place.x && place.x<SL && 0<=place.y && place.y<SL ){
      sprintf( put_cmd, "put %d %d", place.x, place.y );
      write( fd, put_cmd, strlen(put_cmd)+1 );
      break;
    }
  }
}


int main(int argc, char** argv){
  
  int ch;
  extern char *optarg;

  char self;
  char buf[SL*SL+EXTRA];
  char put_cmd[30];// > 10 will be OK.
  int myTurnNum=0;

  if(argc<3) usage(argv[0]);
  char *server;
  server = argv[1];
  int port = atoi(argv[2]);
  if(port==10000) self=1;
  else            self=-1;
  int fd = init_client_socket( TCP_SOCKET, server, port );

  while ((ch = getopt(argc, argv, "bw")) != -1){
    switch (ch){
    case 'b':
      self=1;
      break;
    case 'w':
      self=-1;
      break;
    }
  }

  while(1){
    read(fd,buf,sizeof(buf));
    if(!strncmp("your turn", buf, 9)){
      printf("%s\n",buf);
      myTurnNum++;
      my_turn( fd, put_cmd, self, myTurnNum );
    }else if(!strncmp("1", buf, 1)) printf("%s: success!\n",put_cmd);
    else if(!strncmp("2", buf, 1))  printf("%s: there was a stone!\n",put_cmd);
    else if(!strncmp("3", buf, 1))  printf("out of board!\n");
    else if(!strncmp("4", buf, 1)){
      printf("against the rules (33)!\n");
      my_turn( fd, put_cmd, self, myTurnNum );
    }else if(!strncmp("you win!", buf, 8)){
      printf("you win!\n");
      exit(0);
    }else{
      printf("unreachable\n");
      printf("buf = %s\n",buf);
      exit(-1);
    }
  }
  close(fd);
  return 0;
}

