#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include "renju_client_com.h"
#include "match_tools.h"
void print_board_a(char* board){
  int i,j;
  for( j=0; j<SL; j++){
    for( i=0; i<SL; i++){
      printf("%3d ",board[j*SL+i]);
    }
    printf("\n");
  }
}

static void print_board_b(char board[SL][SL]){
  int i,j;
  for( j=0; j<SL; j++){
    for( i=0; i<SL; i++){
      printf("%3d ",board[j][i]);
    }
    printf("\n");
  }
}
static void print_putable_arr(boardInfo_t *bd){
  int i=0;
  for(i=0; i<bd->putable_arr_length; i++)
    printf("[%d, %d] ",bd->putable_arr[i].x,bd->putable_arr[i].y);
  printf("\n");
}

static int isNon0in8neighbor( char board[SL][SL], int x, int y){
  char thereIsNon0=0;
  if( x==0 && y==0 ){
    if( board[y+1][x+0] != 0 ||
	board[y+1][x+1] != 0 ||
	board[y+0][x+1] != 0
	) 
    thereIsNon0=1;
  }else if( x==SL-1 && y==0 ){
    if( board[y+1][x-1] != 0 ||
	board[y+1][x+0] != 0 ||
	board[y+0][x-1] != 0
	)
      thereIsNon0=1;
  }else if( x==SL-1 && y==SL-1 ){
    if( board[y+0][x-1] != 0 ||
	board[y-1][x-1] != 0 ||
	board[y-1][x+0] != 0
	)
      thereIsNon0=1;
  }else if( x==0 && y==SL-1 ){
    if( board[y+0][x+1] != 0 ||
	board[y-1][x+0] != 0 ||
	board[y-1][x+1] != 0
	)
      thereIsNon0=1;
  }else if( x==0 ){
    if( board[y+1][x+0] != 0 ||
	board[y+1][x+1] != 0 ||
	board[y+0][x+1] != 0 ||
	board[y-1][x+0] != 0 ||
	board[y-1][x+1] != 0
	)
      thereIsNon0=1;
  }else if( y==0 ){
    if( board[y+1][x-1] != 0 ||
	board[y+1][x+0] != 0 ||
	board[y+1][x+1] != 0 ||
	board[y+0][x-1] != 0 ||
	board[y+0][x+1] != 0
	)
      thereIsNon0=1;
  }else if( x==SL-1 ){
    if( board[y+1][x-1] != 0 ||
	board[y+1][x+0] != 0 ||
	board[y+0][x-1] != 0 ||
	board[y-1][x-1] != 0 ||
	board[y-1][x+0] != 0
	)
      thereIsNon0=1;
  }else if( y==SL-1 ){
    if( board[y+0][x-1] != 0 ||
	board[y+0][x+1] != 0 ||
	board[y-1][x-1] != 0 ||
	board[y-1][x+0] != 0 ||
	board[y-1][x+1] != 0
	)
      thereIsNon0=1;
  }else{
    if( board[y+1][x-1] != 0 ||
	board[y+1][x+0] != 0 ||
	board[y+1][x+1] != 0 ||
	board[y+0][x-1] != 0 ||
	board[y+0][x+1] != 0 ||
	board[y-1][x-1] != 0 ||
	board[y-1][x+0] != 0 ||
	board[y-1][x+1] != 0
	)
      thereIsNon0=1;
  }
  if(thereIsNon0==1)
    return 1;
  else
    return 0;
}

static void gen_putable_arr(boardInfo_t *bd){
  int i,j,k=0;
  for( j=0; j<SL; j++){
    for( i=0; i<SL; i++){
      if( bd->board[j][i] == 0 ){
	if( isNon0in8neighbor( bd->board, i, j ) ){
	  bd->putable_arr[k].x = i;
	  bd->putable_arr[k].y = j;
	  k++;
	}
      }
    }
  }
  bd->putable_arr_length = k;
}

static point_t random_place(boardInfo_t *bd){
  int idx = random()%bd->putable_arr_length;
  return bd->putable_arr[idx];
}

static point_t prev_or_next_r( point_t start, matchInfo_t mt ){
  point_t pt;
  if( mt.prev==0 ){
    pt.x=start.x-1;
    pt.y=start.y;
  }else{
    pt.x=start.x+mt.seqn;
    pt.y=start.y;
  }
  return pt;
}
static point_t prev_or_next_rd( point_t start, matchInfo_t mt ){
  point_t pt;
  if( mt.prev==0 ){
    pt.x=start.x-1;
    pt.y=start.y-1;
  }else{
    pt.x=start.x+mt.seqn;
    pt.y=start.y+mt.seqn;
  }
  return pt;
}

static point_t right_and_rightDown_check(boardInfo_t *bd){
  int i,j;
  point_t pt, start;
  int breakFlag=0;
  matchInfo_t mt_r, mt_rd; // right, right down

  for( j=0; j<SL; j++){
    for( i=0; i<SL; i++){
      start.x=i;
      start.y=j;
      match_right( bd, start, bd->enemy, &mt_r );
      if( mt_r.seqn==4 && (!mt_r.prev || !mt_r.next) ){
	pt = prev_or_next_r( start, mt_r );
	breakFlag=1;
	break;
      }else if( mt_r.seqn==3 && (!mt_r.prev || !mt_r.next) ){
	pt = prev_or_next_r( start, mt_r );
	breakFlag=1;
	break;
      }else{
	pt = bd->putable_arr[0];
      }
    }
    if( breakFlag==1 ) break;
  }
  
  if( breakFlag!=1 ){
    for( j=0; j<SL; j++){
      for( i=0; i<SL; i++){
	start.x=i;
	start.y=j;
	match_right_down( bd, start, bd->enemy, &mt_rd );
	if( mt_rd.seqn==4 && (!mt_rd.prev || !mt_rd.next) ){
	  pt = prev_or_next_rd( start, mt_rd );
	  breakFlag=1;
	  printf("r4 breakFlag=%d\n",breakFlag);
	  break;
	}else if( mt_rd.seqn==3 && (!mt_rd.prev || !mt_rd.next) ){
	  pt = prev_or_next_rd( start, mt_rd );
	  breakFlag=1;
	  printf("r3 breakFlag=%d\n",breakFlag);
	  break;
	}else{
	  pt = bd->putable_arr[0];
	}
      }
      if( breakFlag==1 ) break;
    }
  }

  return pt;
}

point_t com(char* buf, char self, int myTurnNum){
  int i,j;
  point_t place;
  boardInfo_t bd;
  bd.self = self;
  bd.enemy = -self;
  for( j=0; j<SL; j++){
    for( i=0; i<SL; i++){
      bd.board[j][i] = buf[j*SL+i];
    }
  }
  
  printf("== myTurnNum : %d\n",myTurnNum);
  printf("== self = %d\n",self);

  static int first=1;
  if( first==1 ){ 
    first=0;
    int sum=0;
    for(j=0; j<SL; j++)
      for(i=0; i<SL; i++)
	sum += bd.board[j][i];
    if( sum==0 ){// first black place 
      place.x=SL/2;
      place.y=SL/2;
      return place;
    }
  }
  gen_putable_arr(&bd);
  place = random_place(&bd); // = right_and_rightDown_check(&bd)
  print_putable_arr(&bd);
  bd.board[place.x][place.y]=bd.self;
  print_board_b(bd.board);
  return place;
}
