#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "renju_client_com.h"
#include "match_tools.h"

int main(int argc, char** argv){
    int player;
    int self;
    char buf[SL*SL+EXTRA];
    point_t place;
    int myTurnNum=0;
    matchInfo_t mt0_r, mt0_rd, mt0_d, mt0_ld;
    matchInfo_t mt1_r, mt1_rd, mt1_d, mt1_ld;
    boardInfo_t bd;
    point_t start;

    if(argc<2) player=0;     
    else       player=atoi(argv[1]);
      
    for(int i=0;i<SL*SL;i++) 
      buf[i]=0;

    while(1){
	if(player==0){
	    self=1;
	    myTurnNum++;
	    place = com(buf,self,myTurnNum);
	    player=1;
	} else {
	    self=-1;
	    place = com(buf,self,myTurnNum);
	    player=0;
	}
	printf("place=[%d, %d]\n", place.x, place.y);
	
	buf[place.x+place.y*SL]=self;

	for(int j=0; j<SL; j++){
	  for(int i=0; i<SL; i++){
	    bd.board[j][i] = buf[j*SL+i];
	  }
	}
	for(int j=0; j<SL; j++){
	  for(int i=0; i<SL; i++){
	    start.x=i;
	    start.y=j;

	    match_right( &bd, start, 1, &mt0_r );
	    match_right( &bd, start, -1, &mt1_r );

	    match_right_down( &bd, start, 1, &mt0_rd );
	    match_right_down( &bd, start, -1, &mt1_rd );

	    match_down( &bd, start, 1, &mt0_d );
	    match_down( &bd, start, -1, &mt1_d );

	    match_left_down( &bd, start, 1, &mt0_ld );
	    match_left_down( &bd, start, -1, &mt1_ld );

	    if( mt0_r.seqn==5  ||
		mt0_rd.seqn==5 ||
		mt0_d.seqn==5  ||
		mt0_ld.seqn==5 ){
	      printf("player 0 win\n");
	      exit(0);
	    }else if( mt1_r.seqn==5  || 
		      mt1_rd.seqn==5 ||
		      mt1_d.seqn==5  ||
		      mt1_ld.seqn==5 ){
	      printf("player 1 win\n");
	      exit(0);
	    }
	  }
	}
    }
	return 0;
}
