#ifndef _SOCKET_WRAPPER_H
#define _SOCKET_WRAPPER_H

enum {TCP_SOCKET=0, UDP_SOCKET, PIPE_SOCKET,};

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

typedef struct {
    int socket_type;
    int fd;

    struct sockaddr_in sock_addr;
    int port;
    socklen_t len;
} sockwrap_t;

#ifdef __cplusplus
extern "C" {
#endif

    sockwrap_t init_server_socket(int socket_type, int port);
    int accept_socket(sockwrap_t* sock);
    int init_client_socket(int socket_type, char* hostname, int port);

#ifdef __cplusplus
}
#endif
#endif

