#!/usr/bin/ruby -Ke

require "net/telnet"

# ̤Υ
SideLength=15

# ̤ξݻ륯饹
class Board
  # ܤξݻ륯饹(Ф롤ޤ϶)
  class Cross
    def initialize
      @black=false
      @white=false
    end
    # Ф֤
    def put_black
      @black=true
    end
    def put_white
      @white=true
    end
    def output_black
      @black
    end
    def output_white
      @white
    end
    # ܤξʸǽ
    def get_color
      if @black
        "black"
      elsif @white
        "white"
      else
        ""
      end
    end
  end # end class Cross
  # ̤ξ᥽å
  def initialize
    @board=Array.new(SideLength){Array.new(SideLength){Cross.new}}
  end
  # ̤ɽ᥽å
  def print_board
    top=0
    side=0
    print "\n"
    @board.each do |row|
      if top==0
        print " "
        for top in 0...SideLength
          print "#{top%10} "
        end
        print "\n"
      end
      print "#{side%10}"
      side+=1
      row.each do |cross|
        if cross.output_black==true then
          print ""
        elsif cross.output_white==true then
          print ""
        else
          print ""
        end
      end
      print "\n"
    end
    print "\n"
  end
  # Ƚ
  def sequence_num_5(row,column,color)
    col_flag=row_flag=diag0_flag=diag1_flag=true
    for delta in 1...5
      if column+delta >= SideLength then
        col_flag=false
        diag0_flag=false
      elsif @board[row][column+delta].get_color!=color then
        col_flag=false
      end
      if row+delta >= SideLength then
        row_flag=false
        diag0_flag=false
        diag1_flag=false
      elsif @board[row+delta][column].get_color!=color then
        row_flag=false
      end
      if diag0_flag==true then
        if @board[row+delta][column+delta].get_color!=color then
          diag0_flag=false
        end
      end
      if diag1_flag==true then
        if column-delta<0 then
          diag1_flag=false
        elsif @board[row+delta][column-delta].get_color!=color then
          diag1_flag=false
        end
      end
      if (col_flag || row_flag || diag0_flag || diag1_flag) == false
        return false
      end
    end
    return true
  end
  # Ƥ뤫ݤȽ̤᥽å
  # ֤ͤ true ʤХץཪλ
  def win
    for row in 0...SideLength do
      for column in 0...SideLength do
        color=@board[row][column].get_color
        if color != ""
          if sequence_num_5(row,column,color)
            win=color
          end
        end
      end
    end
    case win
    when "black"
      print "()ξǤ\n"
      return true
    when "white"
      print "()ξǤ\n"
      return true
    else
      return false
    end
  end

  # 饹ȤΥ󥿡ե
  # ꤷɸФ֤
  def put_black(row,column)
    @board[row][column].put_black
  end
  def put_white(row,column)
    @board[row][column].put_white
  end

  # ꤷɸξ
  def output_black_ext(row,column)
    @board[row][column].output_black
  end
  def output_white_ext(row,column)
    @board[row][column].output_white
  end

  # ꤷɸξʸǽ
  def get_color_ext(row,column)
    if @board[row][column].output_black
      "black"
    elsif @board[row][column].output_white
      "white"
    else
      ""
    end
  end

end # end class Board

# ̤Ф֤饹桼󥿡եͤƤߤꤹ롥
class Play
  # 르ꥺ򵭽Ҥ륯饹
  class Com < Play
    # ̤ξɾ륯饹
    class Eval < Com
      def initialize(board_tmp, self_color)
        @board=board_tmp
        @self_color=self_color
      end
      # ꤷɸ鱦ƱФ¤ǤȤο᥽å
      def match_right(row,column)
        seqNum=0
        if @self_color=="black" then
          enemy_color="white"
        else
          enemy_color="black"
        end
        if row==0 then
          prev_stone=@board.get_color_ext(row,column)
          next_stone=""
          prev_stone=enemy_color # ɤФȸʤ
        elsif (@board.get_color_ext(row,column-1)==@self_color) then
          return -1 #(row, column) ϱü()ФǤϤʤᡤ
        else
          prev_stone=@board.get_color_ext(row,column-1)
        end
        
        while(@board.get_color_ext(row,column+seqNum)==@self_color)
          seqNum+=1
          if column+seqNum>=SideLength then
            next_stone=enemy_color
            wall_flag=true
            break
          end
        end
        
        if !wall_flag then
          next_stone=@board.get_color_ext(row,column+seqNum)
        end

        return seqNum, prev_stone, next_stone
      end
    end # Eval < Com
    # ʬФɸǼ
    def gen_self_enemy_arr
      black=[]
      white=[]
      for row in 0...SideLength
        for column in 0...SideLength
          if @board.output_black_ext(row,column)==true then
            black<<[row,column]
          elsif @board.output_white_ext(row,column)==true then
            white<<[row,column]
          end
        end
        if @self_color == "white"
          @self=white
          @enemy=black
        else
          @self=black
          @enemy=white
        end
      end
    end
    # Ф֤θǼ(֤ƤФ)
    def gen_putable_arr
      putable=[] # putable=both_side_free_3
      if putable == [] then
        all_cross=[]
        all_cross_arround=[]
        all_cross=@self+@enemy
        all_cross.each{ |pt|
          all_cross_arround << [pt[0]-1, pt[1]-1]
          all_cross_arround << [pt[0]-1, pt[1]+0]
          all_cross_arround << [pt[0]-1, pt[1]+1]
          all_cross_arround << [pt[0]+0, pt[1]-1]
          all_cross_arround << [pt[0]+0, pt[1]+1]
          all_cross_arround << [pt[0]+1, pt[1]-1]
          all_cross_arround << [pt[0]+1, pt[1]+0]
          all_cross_arround << [pt[0]+1, pt[1]+1]
        }
        all_cross_arround.reject! {|pt| pt[0]<0 || pt[1]<0 || pt[0]>=SideLength || pt[1]>=SideLength }
        all_cross_arround.uniq!
        all_cross.each{ |pt| 
          all_cross_arround.delete(pt) 
        }
        putable = all_cross_arround.sort
      end
      if putable==[] then
        initial_put=[SideLength/2,SideLength/2]
        putable.push initial_put
      end
      return putable
    end
    # Ф֤䤫
    def random_place
      if @putable.length == 0 then
        place=[SideLength/2,SideLength/2]
      else
        place=@putable[rand(@putable.length)]
      end
      return place
    end
    def run(board_tmp,self_color)
      @board=board_tmp
      @self_color=self_color
      eval=Eval.new(@board, @self_color)
      if @self_color=="black" then
        p eval.match_right(7,7)
      end
      gen_self_enemy_arr
      @putable=gen_putable_arr
      place=random_place
      return place
    end
  end # end class Com < Play
  def initialize
    @board=Board.new
  end
  # Ф֤
  def input_place_black
    while 1 do
      if false then # true->ͤfalse->르ꥺबư
        print "()ιǤ\n"
        print "\",\" ڤФ֤κɸꤷƤ: 10,12\n"
        place=gets.chop!.split(",")
        # ǡ¤ԹǹԤؤäƤΤǡ᤹
        place_tmp=place[1]
        place[1]=place[0]
        place[0]=place_tmp
      else
        place=@com.run(@board,"black")
      end
      print ":[#{place[1]},#{place[0]}]\n"
      begin
        if place[0]==nil || place[1]==nil || place[2]!=nil then raise end
        if Integer(place[0])>=SideLength || Integer(place[0])<0 || Integer(place[1])>=SideLength || Integer(place[1])<0 then raise end
      rescue
        print "ϤηäƤޤ褦ꤤޤ\n"
      else
        begin
          if @board.output_black_ext(Integer(place[0]),Integer(place[1])) || @board.output_white_ext(Integer(place[0]),Integer(place[1]))then raise end
        rescue
          print "ΰ֤ˤϴФ֤Ƥޤ\n"
        else
          @board.put_black(Integer(place[0]),Integer(place[1]))
          break
        ensure
        end
        #        @board.put_black(Integer(place[0]),Integer(place[1]))
      ensure
      end
    end
  end
  # Ф֤
  def input_place_white
    while 1 do
      if false then # true->ͤfalse->르ꥺबư
        print "()ιǤ\n"
        print "\",\" ڤФ֤κɸꤷƤ: 10,12\n"
        place=gets.chop!.split(",")
        # ǡ¤ԹǹԤؤäƤΤǡ᤹
        place_tmp=place[1]
        place[1]=place[0]
        place[0]=place_tmp
      else
        place=@com.run(@board,"white")
      end
      print ":[#{place[1]},#{place[0]}]\n"
      begin
        if place[0]==nil || place[1]==nil || place[2]!=nil then raise end
        if Integer(place[0])>=SideLength || Integer(place[0])<0 || Integer(place[1])>=SideLength || Integer(place[1])<0 then raise end
      rescue
        print "ϤηäƤޤ褦ꤤޤ\n"
      else
        begin
          if @board.output_black_ext(Integer(place[0]),Integer(place[1])) || @board.output_white_ext(Integer(place[0]),Integer(place[1]))then raise end
        rescue
          print "ΰ֤ˤϴФ֤Ƥޤ\n"
        else
          @board.put_white(Integer(place[0]),Integer(place[1]))
          break
        ensure
        end
      ensure
      end
    end
  end
  def run
    @com=Com.new
    phase=false # phase==false -> ֡  phase==true -> 
    while 1 do # Ĥޤǲ
      if !phase then
        input_place_black
        phase=true
      elsif phase then
        input_place_white
        phase=false
      end
      @board.print_board
      if @board.win then  # Ƚ
        break
      end
    end
  end
end # end class Play

class Play_by_client < Play
  # ̤ξ򥵡Ф
  def get_board_text
    @host.puts("get text")
    @host.waitfor(/\W{15}\n/) do |c|
      row=0
      c.each do |line|
        for column in 0...SideLength
          if line[column]==64 then # @=64
            @board.put_black(row,column)
          elsif line[column]==111 then # o=111
            @board.put_white(row,column)
          end
        end
        row+=1
      end
    end
  end
  def run_client(host)
    @com=Com.new
    @host=host
    while 1 do # 夬Ĥޤǲ
      @host.waitfor(/your turn/)
      get_board_text
      if ARGV[1]=="10000"||ARGV[2]=="-b"||ARGV[2]==nil then
        black=true
      elsif ARGV[2]=="-w" then
        black=false
      end
      if black then
        place=@com.run(@board,"black")
      else
        place=@com.run(@board,"white")
      end
      # ǡ¤ԹǹԤؤäƤΤǡ᤹
      place_row=place[1]
      place_column=place[0]
      @host.puts("put #{place_row} #{place_column}")
      @host.waitfor(/\W/) {|c| print c}
    end
  end
end

class Client
  def initialize
    @play_by_client=Play_by_client.new
  end
  # Ф³λ׹ͤ򳫻Ϥ
  def run
    @host=Net::Telnet::new(
                           "Host" => ARGV[0],
                           "Port" => ARGV[1],
                           "Output_log" => "telnetout.log",
                           "Timeout"    => 3600, # 1֤ǥॢ
                           "dump_log" => "telnetdump.log",
                           "Prompt" => /your turn/
                           )
    @play_by_client.run_client(@host)
  end
end

# ARGV[0] ǥСARGV[1] ǥݡȤꡥ
# λ꤬ʤС
if ARGV[0]!=nil && ARGV[1]!=nil then
  Client.new.run
else
  Play.new.run
end

